! Vincent MAGNIN, Polytech Lille, 2008
! gfortran attracteurHenon.f90

PROGRAM Attracteur_de_Henon
	CALL Henon(1.25d0, 0.3d0, "henon1.txt")
	CALL Henon(1.4d0, 0.3d0, "henon2.txt")
	CALL Henon(1.42d0, 0.3d0, "henon3.txt")
END PROGRAM Attracteur_de_Henon

SUBROUTINE Henon(a,b,fichier)
	REAL(8)	:: x,xx,y,yy,a,b
	CHARACTER(*) :: fichier

	x=0d0
	y=0d0
	OPEN (UNIT=1, FILE=fichier, STATUS="REPLACE")
	DO i=1, 10000
		xx=y+1d0-a*x*x
		yy=b*x

		y=yy
		x=xx
		WRITE(1,*) x,y
	END DO
	CLOSE(1)
	
	CALL Lancer_Gnuplot(fichier)
END SUBROUTINE Henon


SUBROUTINE Lancer_Gnuplot(fichier)
	CHARACTER(*) :: fichier

	! On trace le contenu du fichier avec gnuplot
	! en créant un fichier script pour gnuplot :
	OPEN (UNIT=2, FILE="henon.gnuplot", STATUS="REPLACE")
		WRITE(2,*) 'unset key'
		WRITE(2,*) 'set title "Hénon map"'
		WRITE(2,*) 'set xlabel "x"'
		WRITE(2,*) 'set ylabel "y"'
		WRITE(2,*) 'set pointsize 0.01'
		WRITE(2,*) 'plot "'//fichier//'"'
		WRITE(2,*) 'pause -1  "Appuyez sur Entree pour continuer"'
	CLOSE(2)
	! On demande à gnuplot d'exécuter ce script :
	CALL SYSTEM("gnuplot henon.gnuplot")
END SUBROUTINE Lancer_Gnuplot

